Option Explicit On 
Option Strict On
Option Compare Binary

Imports System
Imports System.Windows.Forms

' <remarks>
'   Hauptformular der Anwendung.
' </remarks>
Public Class MainForm
    Inherits System.Windows.Forms.Form

    Private Const WM_QUERYENDSESSION As Int32 = &H11
    Private Const WM_ENDSESSION As Int32 = &H16

    Private m_blnSystemShutdown As Boolean

#Region " Vom Windows Form Designer generierter Code "
    Public Sub New()
        MyBase.New()
        InitializeComponent()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 222)
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "CloseWindow"

    End Sub
#End Region

    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
        ' Wenn Windows sein Beenden ankndigt.
        If m.Msg = WM_QUERYENDSESSION Then

            ' Windows mitteilen, dass die Anwendung beendet werden kann. 
            ' Ist(dies) nicht ohne Probleme der Fall, sollte 0 zurckgegeben 
            ' werden. Dies hat aber unter Windows XP anscheinend keine 
            ' Auswirkung, da Windows trotzdem heruntergefahren wird.
            m.Result = New IntPtr(1)

        ' Windows fordert nun von der Anwendung, 
        ' sich zum Beenden bereit zu machen.
        ElseIf m.Msg = WM_ENDSESSION Then

            ' Wenn wParam = 1, dann wird Windows beendet. 
            ' Hierbei sind verschiedene Flle bei
            ' lteren Windows-Versionen in der MSDN vermerkt, 
            ' die hier nicht bercksichtigt werden.
            If m.WParam.ToInt32() = 1 Then
                Me.SystemShutdown = True
                m.Result = IntPtr.Zero
            End If
        End If
        MyBase.WndProc(m)
    End Sub

    Private Sub MainForm_Closed(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles MyBase.Closed

        ' Der Aufrumcode muss im Ereignis Closed plaziert werden, nicht im 
        ' Ereignis Closing, da zu diesem Zeitpuntk die Ursache fr das Beenden 
        ' noch nicht klar ist.
        MessageBox.Show("Schliessen wegen Herunterfahren oder Abmelden: " & _
            SystemShutdown.ToString() & ".", Application.ProductName, _
            MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    ''' <summary>
    '''   Gibt an oder gibt zurck, ob das System heruntergefahren wird.
    ''' </summary>
    ''' <value>Wert der angibt, ob das System heruntergefahren wird.</value>
    Private Property SystemShutdown() As Boolean
        Get
            Return m_blnSystemShutdown
        End Get
        Set(ByVal Value As Boolean)
            m_blnSystemShutdown = Value
        End Set
    End Property
End Class